#ifndef PARTICLEMANAGERALGOR_H_RIP240
#define PARTICLEMANAGERALGOR_H_RIP240

#include "TestAlgor.h"
#include "Particle.h"
#include "ParticleManager.h"
#include "Util.h"
#include <boost/timer.hpp>
#include <algorithm>
#include <functional>

/**
 * The algorithm using the ParticleManager.
 */
class ParticleManagerAlgor : public TestAlgor {
public:
  ParticleManagerAlgor( int size ) : size( size ) {
  }

  virtual ~ParticleManagerAlgor() {}

  virtual std::string getName() const {
    return "ParticleManager " + toString( size );
  }

  virtual double operator()( int numLoops, float dt ) const {
    using namespace std;

    ParticleManager manager( size );

    boost::timer timer;

    //Run our "game loop"
    for ( int c = 0; c < numLoops; ++c ) {
      manager.addParticle(
        Vector3D( getRandF(), getRandF(), getRandF() ),
        Vector3D( getRandF(), getRandF(), getRandF() ),
        getRandI(),
        getRandF(),
        getRandF() );

      for_each( manager.begin(), manager.end(), bind2nd( mem_fun_ref( &Particle::update1 ), dt ) );
    }

    return timer.elapsed();
  }

private:
  int size;
};

#endif //PARTICLEMANAGERALGOR_H_RIP240
